
#ifndef maindef_h
#define maindef_h

#include "shell.h"

#define ROMTITLE "MoonShell"
#define ROMVERSION "Ver 2.00 beta.1"
#define ROMDATE ""__DATE__" "__TIME__" GMT+09:00"
#define ROMDATESHORT ""__DATE__" "__TIME__""
#define ROMENV "ARM RVCT3.1 [Build 569]"

enum ENextProc {ENP_Loop,ENP_ChkDsk,ENP_Setup,ENP_FileList,ENP_SysMenu,ENP_DPGPlay,ENP_ImageCustom,ENP_ImageView,ENP_TextCustom,ENP_TextView,ENP_Launch,ENP_Custom,ENP_BootROM};
enum EProcFadeEffect {EPFE_None,EPFE_LeftToRight,EPFE_RightToLeft,EPFE_UpToDown,EPFE_DownToUp,EPFE_CrossFade,EPFE_FastCrossFade};

static void SetNextProc(ENextProc _NextProc,EProcFadeEffect _ProcFadeEffect)
{
  extern ENextProc NextProc;
  extern EProcFadeEffect ProcFadeEffect;
  NextProc=_NextProc;
  ProcFadeEffect=_ProcFadeEffect;
}

static void SetProcFadeEffect(EProcFadeEffect _ProcFadeEffect)
{
  extern EProcFadeEffect ProcFadeEffect;
  ProcFadeEffect=_ProcFadeEffect;
}

#include "glib/glib.h"

extern CglFont *pCglFontDefault;

extern void DSP_Open(const char *pFilename,s32 x,s32 y,s32 w,s32 h);
extern void DSP_Close(void);
extern bool DSP_isOpened(void);
extern bool DSP_Update(void);

extern void WaitForVBlank(void);

extern CglB15 *pSettingBGBM,*pTimerBodyBGBM;

extern u32 FolderDlg_TargetItemIndex; // (u32)-1==StartBGM

extern bool isExistsROMEO2;

enum EROMEO2_TriggerType {ER2TT_AButton=0,ER2TT_LButton,ER2TT_RButton,ER2TT_PhoneSwitch};

extern void (*CallBack_Start)(void);
extern void (*CallBack_VsyncUpdate)(u32 VsyncCount);
extern void (*CallBack_End)(void);
extern void (*CallBack_KeyDown)(u32 Keys);
extern void (*CallBack_KeyPress)(u32 VsyncCount,u32 Keys);
extern void (*CallBack_KeyUp)(u32 Keys);
extern void (*CallBack_MouseDown)(s32 x,s32 y);
extern void (*CallBack_MouseMove)(s32 x,s32 y);
extern void (*CallBack_MouseUp)(s32 x,s32 y);
extern void (*CallBack_strpcmRequestStop)(void);
extern void (*CallBack_PanelOpen)(void);
extern void (*CallBack_PanelClose)(void);
extern void (*CallBack_VBlankHandler)(void);
extern void (*CallBack_ROMEO2_HPSwitch_ProcStart)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_ProcEnd)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_Down)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_Up)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_LongStart)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_LongEnd)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_SingleClick)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_SingleLongStart)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_SingleLongEnd)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_DoubleClick)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_DoubleLongStart)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_DoubleLongEnd)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ROMEO2_HPSwitch_TripleClick)(EROMEO2_TriggerType TriggerType);
extern void (*CallBack_ExternalPowerAttach)(void);
extern void (*CallBack_ExternalPowerDetach)(void);

extern void ProcChkDsk_SetCallBack(void);
extern void ProcSetup_SetCallBack(void);
extern void ProcFileList_SetCallBack(void);
extern void ProcSysMenu_SetCallBack(void);
extern void ProcDPGPlay_SetCallBack(void);
extern void ProcImageCustom_SetCallBack(void);
extern void ProcImageView_SetCallBack(void);
extern void ProcTextCustom_SetCallBack(void);
extern void ProcTextView_SetCallBack(void);
extern void ProcLaunch_SetCallBack(void);
extern void ProcCustom_SetCallBack(void);
extern void ProcBootROM_SetCallBack(void);

extern void ScreenMain_Flip_ProcFadeEffect(void);

extern void DrawItemsListToScreenSub(bool ShowCursor);

extern UnicodeChar RelationalFilePathUnicode[MaxFilenameLength];
extern UnicodeChar RelationalFileNameUnicode[MaxFilenameLength];
extern u32 RelationalFilePos;

static inline void RelationalFile_Clear(void)
{
  RelationalFilePathUnicode[0]=0;
  RelationalFileNameUnicode[0]=0;
  RelationalFilePos=0;
}

enum ETextEncode {ETE_Auto=0,ETE_ANSI,ETE_SJIS,ETE_UTF16BE,ETE_UTF16LE,ETE_UTF8};
extern ETextEncode ManualTextEncode;
extern bool ManualTextEncode_OverrideFlag;

#endif

